%define _lto_cflags %{nil}
%global qt_module qtdeclarative
%global __provides_exclude_from ^%{_qt5_archdatadir}/qml/.*\\.so$
%if 0%{?bootstrap}
%global no_examples CONFIG-=compile_examples
%endif

Summary: Qt5 - QtDeclarative component
Name:    qt5-%{qt_module}
Version: 5.15.11
Release: 1%{?dist}
License: LGPLv2 with exceptions or GPLv3 with exceptions
Url:     http://www.qt.io
%global majmin %(echo %{version} | cut -d. -f1-2)
Source0: https://download.qt.io/official_releases/qt/%{majmin}/%{version}/submodules/%{qt_module}-everywhere-opensource-src-%{version}.tar.xz

Patch0000: %{name}-gcc11.patch
Patch0001: qtdeclarative-5.15.0-FixMaxXMaxYExtent.patch

Patch3001:  0001-Remove-unused-QPointer-QQuickPointerMask.patch
Patch3002:  0002-QQmlDelegateModel-Refresh-the-view-when-a-column-is-.patch
Patch3003:  0003-Fix-TapHandler-so-that-it-actually-registers-a-tap.patch
Patch3004:  0004-Revert-Fix-TapHandler-so-that-it-actually-registers-.patch
Patch3005:  0005-Make-sure-QQuickWidget-and-its-offscreen-window-s-sc.patch
Patch3006:  0006-QQuickItem-Guard-against-cycles-in-nextPrevItemInTab.patch
Patch3007:  0007-Don-t-convert-QByteArray-in-startDrag.patch
Patch3008:  0008-Fix-build-after-95290f66b806a307b8da1f72f8fc2c698019.patch
Patch3009:  0009-Implement-accessibility-for-QQuickWidget.patch
Patch3010:  0010-Send-ObjectShow-event-for-visible-components-after-i.patch
Patch3011:  0011-QQuickItem-avoid-emitting-signals-during-destruction.patch
Patch3012:  0012-a11y-track-item-enabled-state.patch
Patch3013:  0013-Make-QaccessibleQuickWidget-private-API.patch
Patch3014:  0014-Qml-Don-t-crash-when-as-casting-to-type-with-errors.patch
Patch3015:  0015-QQmlImportDatabase-Make-sure-the-newly-added-import-.patch
Patch3016:  0016-QQuickState-when-handle-QJSValue-properties-correctl.patch
Patch3017:  0017-Models-Avoid-crashes-when-deleting-cache-items.patch
Patch3018:  0018-qv4function-Fix-crash-due-to-reference-being-invalid.patch
Patch3019:  0019-Quick-Animations-Fix-crash.patch
Patch3020:  0020-Prevent-crash-when-destroying-asynchronous-Loader.patch
Patch3021:  0021-QQuickItem-Fix-effective-visibility-for-items-withou.patch
Patch3022:  0022-Revert-QQuickItem-Fix-effective-visibility-for-items.patch
Patch3023:  0023-Accessibility-respect-value-in-attached-Accessible-i.patch
Patch3024:  0024-qml-tool-Use-QCommandLineParser-process-rather-than-.patch
Patch3025:  0025-JIT-Add-missing-STORE-LOAD-_ACC-to-CreateCallContext.patch
Patch3026:  0026-QQmlJs-MemoryPool-fix-potential-UB-pointer-overflow.patch
Patch3027:  0027-QRecyclePool-fix-potential-UB.patch
Patch3028:  0028-QtQml-Clean-up-QQmlData-ctor.patch
Patch3029:  0029-QML-Make-notify-list-thread-safe.patch
Patch3030:  0030-Flickable-prevent-fixup-from-being-called-while-drag.patch

BuildRequires: make, gcc-c++, qt5-rpm-macros, python3
BuildRequires: qt5-qtbase-devel >= %{version}, qt5-qtbase-private-devel
%{?_qt5:Requires: %{_qt5} = %{_qt5_version}}
%if 0%{?tests}
BuildRequires: dbus-x11, mesa-dri-drivers, time, xorg-x11-server-Xvfb
%endif

%description
%{summary}.

%package devel
Summary: Development files for %{name}
Obsoletes: qt5-qtjsbackend-devel < 5.2.0
Obsoletes: qt5-qtdeclarative-render2d-devel < 5.7.1-10
Provides:  %{name}-private-devel = %{version}-%{release}
Requires: %{name} = %{version}-%{release}
Requires: qt5-qtbase-devel
%description devel
%{summary}.

%package static
Summary: Static library files for %{name}
Requires: %{name}-devel = %{version}-%{release}
%description static
%{summary}.

%package examples
Summary: Programming examples for %{name}
Requires: %{name} = %{version}-%{release}
%description examples
%{summary}.



%prep
%autosetup -n %{qt_module}-everywhere-src-%{version} -p1



%build

ln -s %{__python3} python
export PATH=`pwd`:$PATH

%qmake_qt5

%make_build



%install
%make_install INSTALL_ROOT=%{buildroot}

mkdir %{buildroot}%{_bindir}
pushd %{buildroot}%{_qt5_bindir}
for i in * ; do
  case "${i}" in
    qmlplugindump|qmlprofiler)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt5
      ln -sv ${i} ${i}-qt5
      ;;
    qml|qmlbundle|qmlmin|qmlscene)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt5
      ln -sv ${i} ${i}-qt5
      ;;
    *)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ;;
  esac
done
popd

pushd %{buildroot}%{_qt5_libdir}
for prl_file in libQt5*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  rm -fv "$(basename ${prl_file} .prl).la"
  sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
done
popd



%check
%if 0%{?tests}
export CTEST_OUTPUT_ON_FAILURE=1
export PATH=%{buildroot}%{_qt5_bindir}:$PATH
export LD_LIBRARY_PATH=%{buildroot}%{_qt5_libdir}
make sub-tests-all %{?_smp_mflags}
xvfb-run -a \
dbus-launch --exit-with-session \
time \
make check -k -C tests ||:
%endif



%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig



%files
%license LICENSE.LGPL*
%{_qt5_libdir}/libQt5Qml.so.5*
%{_qt5_libdir}/libQt5QmlModels.so.5*
%{_qt5_libdir}/libQt5QmlWorkerScript.so.5*
%{_qt5_libdir}/libQt5Quick.so.5*
%{_qt5_libdir}/libQt5QuickWidgets.so.5*
%{_qt5_libdir}/libQt5QuickParticles.so.5*
%{_qt5_libdir}/libQt5QuickShapes.so.5*
%{_qt5_libdir}/libQt5QuickTest.so.5*
%{_qt5_plugindir}/qmltooling/
%{_qt5_archdatadir}/qml/

%files devel
%{_bindir}/qml*
%{_qt5_bindir}/qml*
%{_qt5_headerdir}/Qt*/
%{_qt5_libdir}/libQt5Qml.so
%{_qt5_libdir}/libQt5Qml.prl
%{_qt5_libdir}/libQt5QmlModels.so
%{_qt5_libdir}/libQt5QmlModels.prl
%{_qt5_libdir}/libQt5QmlWorkerScript.so
%{_qt5_libdir}/libQt5QmlWorkerScript.prl
%{_qt5_libdir}/libQt5Quick*.so
%{_qt5_libdir}/libQt5Quick*.prl
%dir %{_qt5_libdir}/cmake/Qt5Quick*/
%{_qt5_libdir}/cmake/Qt5*/Qt5*Config*.cmake
%{_qt5_libdir}/metatypes/qt5*_metatypes.json
%{_qt5_libdir}/pkgconfig/Qt5*.pc
%{_qt5_archdatadir}/mkspecs/modules/*.pri
%{_qt5_archdatadir}/mkspecs/features/*.prf
%dir %{_qt5_libdir}/cmake/Qt5Qml/
%{_qt5_libdir}/cmake/Qt5Qml/Qt5Qml_*Factory.cmake
%{_qt5_libdir}/cmake/Qt5QmlImportScanner/

%files static
%{_qt5_libdir}/libQt5QmlDevTools.a
%{_qt5_libdir}/libQt5QmlDevTools.prl
%{_qt5_libdir}/libQt5PacketProtocol.a
%{_qt5_libdir}/libQt5PacketProtocol.prl
%{_qt5_libdir}/libQt5QmlDebug.a
%{_qt5_libdir}/libQt5QmlDebug.prl

%if ! 0%{?no_examples:1}
%files examples
%{_qt5_examplesdir}/
%endif



%changelog
* Mon Jan 08 2024 edwardewang <edwardewang@tencent.com> - 5.15.11-1
- Upgrade to 5.15.11

* Wed Sep 20 2023 kianli <kianli@tencent.com> - 5.15.10-1
- Upgrade to 5.15.10

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.9-2
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Jul 14 2023 Shuo Wang <abushwang@tencent.com> - 5.15.9-1
- update to 5.15.9

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.7-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.7-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Dec 8 2022 Zhao Zhen <jeremiazhao@tencent.com> - 5.15.7-1
- initial
